local nvim_lint = require 'lint'

vim.api.nvim_set_keymap('n', '<LocalLeader>l', ':lua require(\'lint\').try_lint()<CR>', { noremap = true, unique = true })

nvim_lint.linters_by_ft = {
  dockerfile = { 'hadolint' },
  haskell    = { 'hlint' },
  javascript = { 'eslint' },
  lua        = { 'luacheck' },
  markdown   = { 'vale', 'languagetool' },
  python     = { 'pylint', 'mypy', 'flake8' },
  sh         = { 'shellcheck' },
  typescript = { 'eslint' },
  text       = { 'vale', 'languagetool' },
  yaml       = { 'yamllint' },
}

nvim_lint.linters.flake8.args = { '--ignore', 'E133,E501,W503' }
